/********************************************************************
*
*  Filename:   LAB2.C 
*  Purpose:    This file is the main executive for LAB2.
*
*********************************************************************/

/* header files */
#include <p30fxxxx.h>
#include "eeprom.h"     					// lab 2 defines 

/* fuse settings */
_FOSC(CSW_FSCM_OFF & XT_PLL8);   // run at 14.74 MIPs
_FWDT(WDT_OFF);                  // disable WDT
_FBORPOR(PBOR_OFF & MCLR_EN);    // disable PBOR, enable MCLR
_FGS(CODE_PROT_OFF);             // disable code protection


#define	SW5			PORTEbits.RE8		// Deine SW5
#define	SW6			PORTBbits.RB3
#define	DIR_SW5		TRISEbits.TRISE8 	// Define dierection for SW5
#define	DIR_SW6		TRISBbits.TRISB3	

const unsigned int _EEDATA(2) EE_Word_Area [ ] =
				{
				0,1,2,3,4,5,6,7,8,9,0xa,0xb,0xc,0xd,0xe,0xf,
				0x100,0x101,0x102,0x103,0x104,0x105,0x106,0x107,
				0x108,0x109,0x10a,0x10b,0x10c,0x10d,0x10e,0x10f,
				};
unsigned RAM_EE_Data[]={0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,
				18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,
				34,35,36,37,38,39,40,41,42,43,44,45,56,57,48,49,50};
				

unsigned Read_Buffer;
int debounce;
char SW_Input;




/* source code */
/*************************************************************************
*                                                                         
* Function:  main() 
* Purpose:   This is the main executive for LAB2 of the DHO824 class.
*
* Argument:  none
* Returns:   none
*
**************************************************************************/
int main (void) 
{
	while(1)
 	{
   		EraseEE ();   						// Test Erase All EEPROM
		Nop();
		ProgramEEWord(0x55AA,0xFC00);		// Write 0x55AA to the EEPROM location at 0x7FFC00
		Nop();
		EraseEEWord(0xFC00);				// Erase EEPROM location at 0x7FFC00
		Nop();
		ProgramEERow (0xFC40,RAM_EE_Data);	// Program a Row data to the 0x7FFC40
		Nop();
		EraseEERow(0xFC40);					// Erase Row for the 0x7FFC40 
		Nop();
		ProgramEERow (0xFC80,&RAM_EE_Data[16]);	// Program row data to 0x7FFC80
		Nop();
		Read_Buffer=ReadEE(0xFC80);			// Read EEDATA using PSV from 0x7FFC80
		Nop(); 

		while(1);			
	}
}  /* end main() */
    
