// ***********************************************************************
// File : 		I2CSlave_main.C
// ***********************************************************************

#include 	<p30F4011.h>
#include 	"C30EVM_LCD.h"			// NLCD禡쫬ŧiɮקtJ 
#include	<timer.h>				// NTimer禡쫬ŧiɮקtJ
#include	<adc10.h>				// Nadc10禡쫬ŧiɮקtJ
#include	"ADCSubs.h"
#include	"I2CSubs_slave.h"

#define		FCY 	7372800 * 2		// ]ϥWvN~ 7.3728 MHz * 8 Ҧ , C@Og 4  clock
									// ҥH FCY =  (7.3728 * 8 / 4 ) MHz = 7372800* 2

   	_FOSC(CSW_FSCM_OFF & XT_PLL8);   //	XT with 8xPLL oscillator, Failsafe clock off
   	_FWDT(WDT_OFF);                  //	Watchdog timer disabled
  	_FBORPOR(PBOR_OFF & MCLR_EN);    //	Brown-out reset disabled, MCLR reset enabled
   	_FGS(CODE_PROT_OFF);             //	Code protect disabled

const char	My_String1[]="VR1:    VR2:    " ;	// ŧir Program Memory (] const ŧi)
	  char	My_String2[]="RC1:    RC2:    " ;	// ŧir Data Memory

unsigned int 			miliSec ;
volatile int			I2CState = 0  ;
unsigned int			DummyByte ;
volatile unsigned char 	BufferADC1 , BufferADC2 ;
volatile unsigned char 	I2CBuf[64] ;
volatile int			I2CIndexAddress ;

void	Init_ADC(void) ;
void	Show_ADC(void) ;

// union ŧiN8줸ܼByteAccessPSystemFlagcܼƨϥάۦPOA
// HQP榡줸BݨD
union 	{
			unsigned char ByteAccess ;
			struct 	{
						unsigned Bit0: 1 ;
						unsigned Bit1: 1 ;
						unsigned Bit2: 1 ;
						unsigned unused : 5 ;
					} ;
		} SystemFlag ;

//wqOneSecondXеPSystemFlag.Bit0줸ܼơAGNϥΤ@Ӧ줸OЪŶ
#define	OneSecond	SystemFlag.Bit0 	

void _ISR _T1Interrupt(void)		//Timer1_Ƶ{
{

	miliSec += 1 ;

	if (miliSec == 1000)		//C1000NOneSecondXг]w1
		{
			OneSecond = 1 ;
			miliSec  = 0 ;
		} 
	IFS0bits.T1IF = 0 ;		//M_X

}

void	_ISR	_SI2CInterrupt(void)
{
	IFS0bits.SI2CIF = 0 ;

	DummyByte = I2CRCV ;
	I2CSTATbits.I2COV = 0;
	
	if (  !I2CSTATbits.D_A && I2CSTATbits.S )
	{

		I2CState = 0 ;				// 	Reset I2C State !!

		if (I2CSTATbits.R_W )		//	Read Command
		{
     		I2CTRN = (unsigned char) I2CBuf[I2CIndexAddress++] ;      	/* data transferred to I2CTRN reg */
     		I2CCONbits.SCLREL = 1;		/* Release the clock */
		}

		else						// Write Command 
			{

				I2CState = 1 ;
				Nop( );
			}
		
	}

			else if ( I2CSTATbits.P )				//	pGO STOP , N I2CState Mᵲ
				{	
					Nop();
					I2CState = 0 ;	
				}
		
			else									// Write Command 
			{
				if ( I2CState == 1 )				// 	Internal address byte
				{
					I2CState = 2 ;
					I2CIndexAddress = DummyByte ;

					if ( I2CIndexAddress >= 63 )	
						 I2CIndexAddress = 63 ;
				}

				else if ( I2CState >= 2 )
				{
					I2CBuf[I2CIndexAddress++] = DummyByte ;
				}

				else	Nop();
			}
	

}

	unsigned int 	ADC_Value;
	unsigned char 	EEPROM_Data1 , EEPROM_Data2 ;
	int				WaitLoop ;

int	main( void )
{


	Init_ADC( ) ;										// NADCilƳ]w
	Init_I2C( ) ;

	OpenLCD( ) ;										// ϥ OpenLCD( ) LCD Ҳէ@lƳ]w
														// 4 bits Data mode
														// 5 * 7 Character 

	setcurLCD(0,0) ;									// ϥ setcurLCD( ) ]wЩ (0,0)
	putrsLCD( My_String1 ) ;							// Nsb Program Memory rϥ
														// putrsLCD( ) LX LCD
			
	setcurLCD(0,1) ;									// ϥ setcurLCD( ) ]wЩ (0,1)
	putrsLCD( My_String2 ) ;							// Nsb Data Memory rϥ
														// putsLCD( ) LX LCD

	ConfigIntTimer1( T1_INT_PRIOR_7 & T1_INT_ON ) ;		// Timer1 _uų] 7 (̰)
														// Timer1 _ ON 

	OpenTimer1( T1_ON & T1_IDLE_STOP & T1_GATE_OFF & 			// Timer1  Period ]C 1ms 
				T1_PS_1_1 & T1_SYNC_EXT_OFF & T1_SOURCE_INT ,
				(FCY/ 1000) ) ;

	OneSecond = 0 ;

	while(1) 
	{	
		if ( OneSecond ) 								// ߰ Timer1  Period ɶO_w
														// iHγnˬdO_ǽT 1 ms
		{
			OneSecond = 0 ;							 
					
			ADC_Value = Get_VR1( ) ;								
			setcurLCD(4,0) ;							// Set LCD cursor		
			put_Num_LCD( ADC_Value >> 2 ) ;				// NഫGHQiƦrܦܲGܾ

				BufferADC1 = ADC_Value >> 2 ;

			ADC_Value = Get_VR2( ) ;								
			setcurLCD(12,0) ;							// Set LCD cursor		
			put_Num_LCD( ADC_Value >> 2 ) ;				// NഫGHQiƦrܦܲGܾ	

				BufferADC2 = ADC_Value >> 2 ;

			setcurLCD(4,1) ;
			put_Num_LCD(I2CBuf[0x10] ) ;
			setcurLCD(12,1) ;
			put_Num_LCD(I2CBuf[0x20] ) ;

		}
	}		
}


