// ***********************************************************************
// Purpose : 	mߦpϥ Output Comparator 1 Ӳ PWM X
//				PWM X Duty Cycle 
//			
//				ϥΪ禡w:		adc10
//									timer
//									outcompare
//				
// ***********************************************************************

#include 	<p30fxxxx.h>
#include	<adc10.h>				// Nadc10禡쫬ŧiɮקtJ
#include	<timer.h>				// NTimer禡쫬ŧiɮקtJ
#include	<outcompare.h>			// NCompare禡쫬ŧiɮקtJ

#define		FCY 	7372800 * 2		// ]ϥWvN~ 7.3728 MHz * 8 Ҧ , C@Og 4  clock
									// ҥH FCY =  (7.3728 * 8 / 4 ) MHz = 7372800* 2

   	_FOSC(CSW_FSCM_OFF & XT_PLL8);   //	XT with 8xPLL oscillator, Failsafe clock off
   	_FWDT(WDT_OFF);                  //	Watchdog timer disabled
  	_FBORPOR(PBOR_OFF & MCLR_EN);    //	Brown-out reset disabled, MCLR reset enabled
   	_FGS(CODE_PROT_OFF);             //	Code protect disabled

#define		LED1		LATEbits.LATE0 
#define		CTRL_LED1	TRISEbits.TRISE0

void	Init_ADC(void) ;
void Init_Timer2(void);
unsigned int Read_VR2(void);
void	Init_OC1(void) ;

void __attribute__((interrupt, no_auto_psv)) _T2Interrupt(void)
{
	OC1RS=Read_VR2( );
	LED1=!LED1;
	IFS0bits.T2IF = 0 ;

} 

int	main( void )
{
	SRbits.IPL=4;

	Init_ADC( ) ;										// NADCilƳ]w
	Init_Timer2( );
	Init_OC1();
	TRISDbits.TRISD0=0;
	CTRL_LED1 = 0 ;

	while(1); 
}

/***********************************************/
// Subroutine to configure the OC module

void	Init_OC1(void)
{
 	CloseOC1();

 	ConfigIntOC1(OC_INT_OFF & OC_INT_PRIOR_7);
//	IEC0bits.OC1IE = 0 ;
//	IFS0bits.OC1IF = 0 ;
//	IPC0bits.OC1IP = 7 ;

	OpenOC1(OC_IDLE_CON & OC_TIMER2_SRC &
			OC_PWM_FAULT_PIN_DISABLE, 0, 0);
//	OC1CON= 0x0006;
}

/***********************************************/
// Subroutine to configure the A/D module

void	Init_ADC(void)
{

	unsigned int Channel, PinConfig, Scanselect, Adcon3_reg, Adcon2_reg, Adcon1_reg;

	ADCON1bits.ADON = 0; /* turn off ADC */

	PinConfig = ENABLE_AN0_ANA;			// Select port pins as analog inputs ADPCFG<15:0>

	Adcon1_reg = ADC_MODULE_ON &		// Turn on A/D module (ADON)
		ADC_IDLE_STOP &					// ADC turned off during idle (ADSIDL)
		ADC_FORMAT_INTG &				// Output in integer format (FORM)
		ADC_CLK_MANUAL &				// Conversion trigger manually (SSRC)
		ADC_SAMPLE_INDIVIDUAL &			// Sample channels individually (SIMSAM)
		ADC_AUTO_SAMPLING_OFF;			// Sample trigger manually (ASAM)

	Adcon2_reg = ADC_VREF_AVDD_AVSS &	// Voltage reference : +AVdd, -AVss (VCFG)
		ADC_SCAN_OFF &					// Scan off (CSCNA)
		ADC_ALT_BUF_OFF &				// Use fixed buffer (BUFM)
		ADC_ALT_INPUT_OFF &				// Does not alternate between MUX A & MUX B (ALTS)
		ADC_CONVERT_CH0 &				// Convert only channel 0 (CHPS)
		ADC_SAMPLES_PER_INT_1;			// 1 sample between interrupt (SMPI)

	Adcon3_reg = ADC_SAMPLE_TIME_10 &	// Auto-Sample time (SAMC)
		ADC_CONV_CLK_SYSTEM &			// Use system clock (ADRC)
		ADC_CONV_CLK_4Tcy;				// Conversion clock = 4 Tcy (ADCS)
										// ADCS = 2*(154ns)/(1/Fcy)-1 = 3.5416

	Scanselect = SCAN_NONE;				// ADC scan no channel (ADCSSL)

	OpenADC10(Adcon1_reg, Adcon2_reg, Adcon3_reg, PinConfig, Scanselect);

	Channel = ADC_CH0_POS_SAMPLEA_AN0 & // CH0 Pos. : AN0, Neg. : Nominal Vref- Defined in ADCON2
		ADC_CH0_NEG_SAMPLEA_NVREF ;		// (ADCHS)
	SetChanADC10(Channel);

	ConfigIntADC10(ADC_INT_DISABLE);	// Disable ADC interrupt

}

/***********************************************/
// Subroutine to configure the Timer 2

void Init_Timer2(void)
{
	ConfigIntTimer2( T2_INT_PRIOR_6 & T2_INT_ON ) ;		// Timer2 _uų] 6  
															// Timer2 _ OFF 

	OpenTimer2( T2_ON & T2_IDLE_STOP & T2_GATE_OFF & 			// Timer2  Period ]C 64ms 
				T2_PS_1_1 & T2_32BIT_MODE_OFF & 
				T2_SOURCE_INT, 
			    1023) ;
}
/***********************************************/
// Subroutine to read analog voltage from VR2

unsigned int Read_VR2(void)
{
	unsigned char Loop ;

	ADCON1bits.SAMP = 1; 		// start sampling ...

	for  ( Loop = 0 ; Loop < 100 ; Loop ++ );

	ConvertADC10();
	while (BusyADC10()); 		// conversion done?
	return ADCBUF0 ; 			// get ADC value
}

